org.apache.fop.layoutmgr

## Class SpaceResolver

- java.lang.Object
- - org.apache.fop.layoutmgr.SpaceResolver

    public final class SpaceResolver
    extends Object

This class resolves spaces and conditional borders and paddings by replacing the UnresolvedListElements descendants by the right combination of KnuthElements on an element list.

### Nested Class Summary

Nested Classes
`static class` `SpaceResolver.SpaceHandlingBreakPosition` Position class for break possibilities.
`static class` `SpaceResolver.SpaceHandlingPosition` Position class for no-break situations.

### Method Summary

All Methods Static Methods Concrete Methods
`static void` `performConditionalsNotification(List effectiveList, int startElementIndex, int endElementIndex, int prevBreak)` Inspects an effective element list and notifies all layout managers about the state of the spaces and conditional lengths.
`static void` `resolveElementList(List elems)` Resolves unresolved elements applying the space resolution rules defined in 4.3.1.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### resolveElementList

    public static void resolveElementList(List elems)

Resolves unresolved elements applying the space resolution rules defined in 4.3.1.

Parameters:
  `elems` - the element list

#### performConditionalsNotification

    public static void performConditionalsNotification(List effectiveList,
                                                       int startElementIndex,
                                                       int endElementIndex,
                                                       int prevBreak)

Inspects an effective element list and notifies all layout managers about the state of the spaces and conditional lengths.

Parameters:
  `effectiveList` - the effective element list
  `startElementIndex` - index of the first element in the part to be processed
  `endElementIndex` - index of the last element in the part to be processed
  `prevBreak` - index of the the break possibility just before this part (used to identify a break condition, lastBreak <= 0 represents a no-break condition)